--+--------------------------------------------------------------------------+
--| Copyright 1992 - 2002 Rational Software Corporation. All Rights Reserved.|
--| This software contains proprietary and confidential information of       |
--| Rational and its suppliers. Use, disclosure or reproduction is           |
--| prohibited without the prior express written consent of Rational.        |
--+--------------------------------------------------------------------------+
--
with Apex.Unix_Constants;
with Apex.Unix_Types;

package Tm_Simple_Io is

    Stdin  : constant Apex.Unix_Types.Int :=
       Apex.Unix_Constants.Unix_Unistd.Stdin_Fileno;
    Stdout : constant Apex.Unix_Types.Int :=
       Apex.Unix_Constants.Unix_Unistd.Stdout_Fileno;
    Stderr : constant Apex.Unix_Types.Int :=
       Apex.Unix_Constants.Unix_Unistd.Stderr_Fileno;

    procedure Put (Char : Character; Fildes : Apex.Unix_Types.Int := Stdout);
    procedure Put (Str : String; Fildes : Apex.Unix_Types.Int := Stdout);

    procedure Put_Line (Str : String; Fildes : Apex.Unix_Types.Int := Stdout);
    procedure New_Line (Count  : Integer             := 1;
                        Fildes : Apex.Unix_Types.Int := Stdout);


    procedure Get (Ch     : out Character;
                   Eof    : out Boolean;
                   Fildes : Apex.Unix_Types.Int := Stdin);

    procedure Get (Str                    : out String;
                   Eof                    : out Boolean;
                   Strip_Line_Terminators : in Boolean          := True;
                   Fildes                 : Apex.Unix_Types.Int := Stdin);
    --
    -- Str may not be completely full if EOF is encountered.    
    --

    procedure Get_Line (Str    : out String;
                        Last   : out Natural;
                        Eof    : out Boolean;
                        Fildes : Apex.Unix_Types.Int := Stdin);

private

    pragma Suppress (Elaboration_Check, On => Put);
    pragma Suppress (Elaboration_Check, On => Put_Line);
    pragma Suppress (Elaboration_Check, On => New_Line);

    pragma Suppress (Elaboration_Check, On => Get);
    pragma Suppress (Elaboration_Check, On => Get_Line);

end Tm_Simple_Io;
