-- Copyright (C) 1995-1996,1999-2000 Rational Software Corporation.
-- All rights reserved.

--
------------------------------------------------------------------------------
-- RESTRICTED RIGHTS LEGEND
--
-- Use, duplication, or disclosure by the Government and Boeing is subject to
-- restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
-- Technical Data and Computer Software clause of DFAR 252.227-7013 and in
-- similiar clauses in the FAR and NASA FAR Supplement.
------------------------------------------------------------------------------
-- PROPRIETARY AND CONFIDENTIAL INFORMATION OF RATIONAL SOFTWARE CORP.,
-- USE OR COPYING WITHOUT EXPRESS WRITTEN AUTHORIZATION IS STRICTLY PROHIBITED.
-- THIS MATERIAL IS PROTECTED AS AN UNPUBLISHED WORK UNDER THE U.S. COPYRIGHT
-- ACT OF 1976.  CREATED 1995.  ALL RIGHTS RESERVED.
------------------------------------------------------------------------------
--
-- File Name: tm_mcdc_score_data.1.ada
--

-- This package declares the scorecard object.
--
-- The scorecard object must be allocated statically and statically
-- initialized to 0.  Initialization during elaboration would be too late
-- because 1. we would miss decision points that happen in previous unit
-- elaborations, and 2. we would miss decision points in the runtimes
-- (if we are collecting coverage over the runtime code).  Hence the use
-- of pragma Not_Elaborated.
--

with Tm_Mcdc_Score_Support;
package Tm_Mcdc_Score_Data is
    pragma Not_Elaborated;

    package Unit_Map renames Tm_Mcdc_Score_Support.Unit_Map;
    package Unit_Id_Map renames Tm_Mcdc_Score_Support.Unit_Id_Map;

    The_Scorecard : Tm_Mcdc_Score_Support.Scorecard :=
       (Unit_Map.Map'(others => null), Unit_Id_Map.Map'(others => null));
    --
    -- This object holds the data of the active scorecard.
    -- It is statically initialized to all 0.
    --

    Coverage_Collection_Disabled : Boolean := False;
    --
    -- Flag to temporarily or permanently stop data collection.
    -- Note that this doesn't really work in a multi-tasking environment.
    --

end Tm_Mcdc_Score_Data;

