--+--------------------------------------------------------------------------+
--| Copyright 1992 - 2002 Rational Software Corporation. All Rights Reserved.|
--| This software contains proprietary and confidential information of       |
--| Rational and its suppliers. Use, disclosure or reproduction is           |
--| prohibited without the prior express written consent of Rational.        |
--+--------------------------------------------------------------------------+
--
with Unix_Operations_Extension;
with Tms_Communications;


procedure Import_Server_Port (Server : out Apex.Unix_Types.Int;
                              Port   : out Apex.Unix_Types.Int) is
    --
    --[internal] -- We cannot (should not) use Tm_Environment to 
    --[internal] -- provide Getenv functionality,
    --[internal] -- since it will bloat the users's executable 
    --[internal] -- and the API with the entire Log/Error closure!
    --
    C_Port_Id_Env : constant String          :=
       Tms_Communications.Port_Id_Env & Ascii.Nul;
    Env_Ptr       : Apex.Unix_Types.Char_Ptr :=
       Unix_Operations_Extension.Getenv
          (Apex.Unix_Types.To_Char_Ptr
              (C_Port_Id_Env (C_Port_Id_Env'First)'Address));

    function "=" (L, R : Apex.Unix_Types.Char_Ptr) return Boolean
       renames Apex.Unix_Types."=";

    function Locate (Fragment : Character; Within : String) return Natural is
    begin
	for I in Within'Range loop
	    if Fragment = Within (I) then
		return I;
	    end if;
	end loop;
    end Locate;


begin
    if Env_Ptr = null then
	Server := 0;
	Port   := 0;
    else
	declare
            Env_Val : constant String  := Apex.Unix_Types.To_String (Env_Ptr);
            Colon   : constant Natural := Locate (':', Env_Val);
	    S       : constant String  := Env_Val (Env_Val'First .. Colon - 1);
	    P       : constant String  := Env_Val (Colon + 1 .. Env_Val'Last);
        begin
            Server := Apex.Unix_Types.Int'Value (S);
            Port   := Apex.Unix_Types.Int'Value (P);
        end;
    end if;
end Import_Server_Port;
